module assert_2;

import std.stdio;
import std.string;
import std.exception;

/* Verilen mesajı kullanıcıya gösterir ve girilen zaman
 * bilgisini saat ve dakika olarak okur. */
void zamanOku(string mesaj, out int saat, out int dakika) {
    write(mesaj, "? (SS:DD) ");

    readf(" %s:%s", &saat, &dakika);

    enforce((saat >= 0) && (saat <= 23) &&
            (dakika >= 0) && (dakika <= 59),
            "Geçersiz zaman!");
}

/* Zamanı dizgi düzeninde döndürür. */
string zamanDizgisi(int saat, int dakika) {
    assert((saat >= 0) && (saat <= 23));
    assert((dakika >= 0) && (dakika <= 59));

    return format("%02s:%02s", saat, dakika);
}

/* İki zaman bilgisini birbirine ekler ve üçüncü parametre
 * çifti olarak döndürür. */
void zamanEkle(
        int başlangıçSaati, int başlangıçDakikası,
        int eklenecekSaat, int eklenecekDakika,
        out int sonuçSaati, out int sonuçDakikası) {
    sonuçSaati = başlangıçSaati + eklenecekSaat;
    sonuçDakikası = başlangıçDakikası + eklenecekDakika;

    if (sonuçDakikası > 59) {
        ++sonuçSaati;
    }
}

/* Sayılardan sonra kesme işaretiyle ayrılarak kullanılacak
 * olan "de, da" ekini döndürür. */
string daEki(int sayı) {
    string ek;

    immutable int sonHane = sayı % 10;

    switch (sonHane) {

    case 1, 2, 7, 8:
        ek = "de";
        break;

    case 3, 4, 5:
        ek = "te";
        break;

    case 6, 9:
        ek = "da";
        break;

    default:
        break;
    }

    assert(ek.length != 0);

    return ek;
}

void main() {
    int başlangıçSaati;
    int başlangıçDakikası;
    zamanOku("Başlangıç zamanı",
             başlangıçDakikası, başlangıçSaati);

    int işlemSaati;
    int işlemDakikası;
    zamanOku("İşlem süresi", işlemSaati, işlemDakikası);

    int bitişSaati;
    int bitişDakikası;
    zamanEkle(başlangıçSaati, başlangıçDakikası,
              işlemSaati, işlemDakikası,
              bitişSaati, bitişDakikası);

    sonucuYazdır(başlangıçSaati, başlangıçDakikası,
                 işlemSaati, işlemDakikası,
                 bitişSaati, bitişDakikası);
}

void sonucuYazdır(
        int başlangıçSaati, int başlangıçDakikası,
        int işlemSaati, int işlemDakikası,
        int bitişSaati, int bitişDakikası) {
    writef("%s'%s başlayan",
           zamanDizgisi(başlangıçSaati, başlangıçDakikası),
           daEki(başlangıçDakikası));

    writef(" ve %s saat %s dakika süren işlem",
           işlemSaati, işlemDakikası);

    writef(" %s'%s sonlanır.",
           zamanDizgisi(bitişSaati, bitişDakikası),
           daEki(bitişDakikası));

    writeln();
}
