module deneme;

import std.stdio;

interface Hayvan {
    string ses();
}

class Kedi : Hayvan {
    string ses() {
        return "miyav";
    }
}

class Köpek : Hayvan {
    string ses() {
        return "hav";
    }
}

void main() {
    string[] kurulacaklar = [ "Kedi", "Köpek", "Kedi" ];

    Hayvan[] hayvanlar;

    foreach (türİsmi; kurulacaklar) {
        /* "Sözde değişken" __MODULE__, her zaman için içinde
         * bulunulan modülün ismidir ve bir string olarak
         * derleme zamanında kullanılabilir. */
        const tamİsim = __MODULE__ ~ '.' ~ türİsmi;
        writefln("%s kuruluyor", tamİsim);
        hayvanlar ~= cast(Hayvan)Object.factory(tamİsim);
    }

    foreach (hayvan; hayvanlar) {
        writeln(hayvan.ses());
    }
}
