module bellek_yonetimi_6;

import std.stdio;
void nesneYerleşiminiYazdır(T)()
        if (is (T == struct) || is (T == union)) {
    import std.stdio;
    import std.string;

    writefln("=== '%s' nesnelerinin yerleşimi" ~
             " (.sizeof: %s, .alignof: %s) ===",
             T.stringof, T.sizeof, T.alignof);

    /* Tek satır bilgi yazar. */
    void satırYazdır(size_t uzaklık, string bilgi) {
        writefln("%4s: %s", uzaklık, bilgi);
    }

    /* Doldurma varsa miktarını yazdırır. */
    void doldurmaBilgisiYazdır(size_t beklenenUzaklık,
                               size_t gözlemlenenUzaklık) {
        if (beklenenUzaklık < gözlemlenenUzaklık) {
            /* Gözlemlenen uzaklık beklenenden fazlaysa
             * doldurma baytı var demektir. */

            const doldurmaMiktarı =
                gözlemlenenUzaklık - beklenenUzaklık;

            satırYazdır(beklenenUzaklık,
                        format("... %s bayt DOLDURMA",
                               doldurmaMiktarı));
        }
    }

    /* Bir sonraki üyenin doldurma olmayan durumda nerede
     * olacağı bilgisini tutar. */
    size_t doldurmasızUzaklık = 0;

    /* Not: __traits(allMembers) bir türün üyelerinin
     * isimlerinden oluşan bir 'string' topluluğudur. */
    foreach (üyeİsmi; __traits(allMembers, T)) {
        mixin (format("alias üye = %s.%s;",
                      T.stringof, üyeİsmi));

        const uzaklık = üye.offsetof;
        doldurmaBilgisiYazdır(doldurmasızUzaklık, uzaklık);

        const türİsmi = typeof(üye).stringof;
        satırYazdır(uzaklık, format("%s %s", türİsmi, üyeİsmi));

        doldurmasızUzaklık = uzaklık + üye.sizeof;
    }

    doldurmaBilgisiYazdır(doldurmasızUzaklık, T.sizeof);
}
align (2)               // 'S' nesnelerinin hizalama birimi
struct S {
    byte b;
    align (1) int i;    // 'i' üyesinin hizalama birimi
    ubyte u;
}

void main() {
    nesneYerleşiminiYazdır!S();
}
