module deger_referans_4;

import std.stdio;
import std.array;

int modülDeğişkeni = 9;

class BirSınıf {
    int üye;
}

void başlıkÇiz() {
    immutable dchar[] başlık =
        "                    Değişken Türü" ~
        "                    a == b  &a == &b";

    writeln();
    writeln(başlık);
    writeln(replicate("=", başlık.length));
}

void bilgiSatırı(const dchar[] başlık,
                 bool değerEşitliği,
                 bool adresEşitliği) {
    writefln("%50s%9s%9s",
             başlık, değerEşitliği, adresEşitliği);
}

void main() {
    başlıkÇiz();

    int sayı1 = 12;
    int sayı2 = 12;
    bilgiSatırı("aynı değerli değişkenler (değer türü)",
                sayı1 == sayı2,
                &sayı1 == &sayı2);

    int sayı3 = 3;
    bilgiSatırı("farklı değerli değişkenler (değer türü)",
                sayı1 == sayı3,
                &sayı1 == &sayı3);

    int[] dilim = [ 4 ];
    foreach (i, ref eleman; dilim) {
        bilgiSatırı("ref değişkenli foreach",
                    eleman == dilim[i],
                    &eleman == &dilim[i]);
    }

    foreach (i, eleman; dilim) {
        bilgiSatırı("ref olmayan değişkenli foreach",
                    eleman == dilim[i],
                    &eleman == &dilim[i]);
    }

    outParametre(modülDeğişkeni);
    refParametre(modülDeğişkeni);
    inParametre(modülDeğişkeni);

    int[] uzunDilim = [ 5, 6, 7 ];
    int[] dilim1 = uzunDilim;
    int[] dilim2 = dilim1;
    bilgiSatırı("aynı elemanlara erişen dilimler",
                dilim1 == dilim2,
                &dilim1 == &dilim2);

    int[] dilim3 = dilim1[0 .. $ - 1];
    bilgiSatırı("farklı elemanlara erişen dilimler",
                dilim1 == dilim3,
                &dilim1 == &dilim3);

    auto değişken1 = new BirSınıf;
    auto değişken2 = değişken1;
    bilgiSatırı(
        "aynı nesneye erişen BirSınıf'lar (referans türü)",
        değişken1 == değişken2,
        &değişken1 == &değişken2);

    auto değişken3 = new BirSınıf;
    bilgiSatırı(
        "farklı nesneye erişen BirSınıf'lar (referans türü)",
        değişken1 == değişken3,
        &değişken1 == &değişken3);
}

void outParametre(out int parametre) {
    bilgiSatırı("out parametreli işlev",
                parametre == modülDeğişkeni,
                &parametre == &modülDeğişkeni);
}

void refParametre(ref int parametre) {
    bilgiSatırı("ref parametreli işlev",
                parametre == modülDeğişkeni,
                &parametre == &modülDeğişkeni);
}

void inParametre(in int parametre) {
    bilgiSatırı("in parametreli işlev",
                parametre == modülDeğişkeni,
                &parametre == &modülDeğişkeni);
}
