module es_zamanli_16;

import std.stdio;
import std.concurrency;
import core.thread;

struct Sonlan {
}

void main() {
    // Eşinin ismi "ikinci" olan bir iş parçacığı
    auto birinci = spawn(&oyuncu, "ikinci");
    register("birinci", birinci);
    scope(exit) unregister("birinci");

    // Eşinin ismi "birinci" olan bir iş parçacığı
    auto ikinci = spawn(&oyuncu, "birinci");
    register("ikinci", ikinci);
    scope(exit) unregister("ikinci");

    Thread.sleep(2.seconds);

    prioritySend(birinci, Sonlan());
    prioritySend(ikinci, Sonlan());

    // unregister() çağrıları iş parçacıkları sonlandıktan
    // sonra işletilsinler diye main() beklemelidir.
    thread_joinAll();
}

void oyuncu(string eşİsmi) {
    Tid eş;

    while (eş == Tid.init) {
        Thread.sleep(1.msecs);
        eş = locate(eşİsmi);
    }

    bool devam_mı = true;

    while (devam_mı) {
        eş.send("merhaba " ~ eşİsmi);
        receive(
            (string mesaj) {
                writeln("Mesaj: ", mesaj);
                Thread.sleep(500.msecs);
            },

            (Sonlan mesaj) {
                writefln("%s, ben çıkıyorum.", eşİsmi);
                devam_mı = false;
            });
    }
}
