module interface_4;

import std.stdio;

/* Bu arayüz 'ses' işlevini gerektirir. */
interface SesliAlet {
    string ses();
}

/* Bu sınıfın yalnızca 'ses' işlevini tanımlaması gerekir. */
class Çan : SesliAlet {
    string ses() {
        return "çın";
    }
}

/* Bu arayüz 'ses' işlevine ek olarak 'akortEt' işlevini de
 * gerektirir. */
interface MüzikAleti : SesliAlet {
    void akortEt();
}

/* Bu sınıfın 'ses' ve 'akortEt' işlevlerini tanımlaması
 * gerekir. */
class Keman : MüzikAleti {
    string ses() {
        return "♩♪♪";
    }

    void akortEt() {
        // ... kemanın akort işlemleri ...
    }
}

/* Bu arayüz 'konuş' ve 'dinle' işlevlerini gerektirir. */
interface HaberleşmeAleti {
    void konuş(string mesaj);
    string dinle();
}

/* Bu sınıfın 'ses', 'konuş', ve 'dinle' işlevlerini
 * tanımlaması gerekir. */
class Telefon : SesliAlet, HaberleşmeAleti {
    string ses() {
        return "zırrr zırrr";
    }

    void konuş(string mesaj) {
        // ... mesajın hatta iletilmesi ...
    }

    string dinle() {
        string hattaDuyulanSes;
        // ... sesin hattan okunması ...
        return hattaDuyulanSes;
    }
}

class Saat {
    // ... Saat'in gerçekleştirilmesi ...
}

/* Bu sınıfın yalnızca 'ses' işlevini tanımlaması gerekir. */
class ÇalarSaat : Saat, SesliAlet {
    string ses() {
        return "bi bi biip";
    }

    // ... ÇalarSaat'in gerçekleştirilmesi ...
}

void main() {
    SesliAlet[] aletler;

    aletler ~= new Çan;
    aletler ~= new Keman;
    aletler ~= new Telefon;
    aletler ~= new ÇalarSaat;

    foreach (alet; aletler) {
        writeln(alet.ses());
    }
}
