module islec_yukleme_7;

import std.stdio;
import std.string;

struct Süre {
    int dakika;
}

struct GününSaati {
    int saat;
    int dakika;

    ref GününSaati opOpAssign(string işleç)(Süre süre)
            if (işleç == "+") {
        dakika += süre.dakika;

        saat += dakika / 60;
        dakika %= 60;
        saat %= 24;

        return this;
    }

    int opCmp(GününSaati sağdaki) const {
        return (saat == sağdaki.saat
                ? dakika - sağdaki.dakika
                : saat - sağdaki.saat);
    }

    string toString() const {
        return format("%02s:%02s", saat, dakika);
    }
}

struct ZamanAralığı {
    GününSaati baş;
    GününSaati son;    // son aralığın dışında kabul edilir

    bool opBinaryRight(string işleç)(GününSaati zaman) const
            if (işleç == "in") {
        return (zaman >= baş) && (zaman < son);
    }
}

void main() {
    auto öğleTatili = ZamanAralığı(GününSaati(12, 00),
                                   GününSaati(13, 00));

    for (auto zaman = GününSaati(11, 30);
         zaman < GününSaati(13, 30);
         zaman += Süre(15)) {

        if (zaman in öğleTatili) {
            writeln(zaman, " öğle tatilinde");

        } else {
            writeln(zaman, " öğle tatili dışında");
        }
    }
}
