module kapamalar_10;

import std.stdio;
import std.string;

struct Nokta {
    int x;
    int y;

    string toString() const {
        return format("(%s,%s)", x, y);
    }
}

struct Renk {
    ubyte r;
    ubyte g;
    ubyte b;

    string toString() const {
        return format("RGB:%s,%s,%s", r, g, b);
    }
}

struct RenkliNokta {
    Renk renk;
    Nokta nokta;

    string toString() const {
        // Bu, Renk.toString ve Nokta.toString'den yararlanıyor:
        return format("{%s;%s}", renk, nokta);
    }
}

struct Poligon {
    RenkliNokta[] noktalar;

    string toString() const {
        // Bu, RenkliNokta.toString'den yararlanıyor
        return format("%s", noktalar);
    }
}

void main() {
    auto poligon = Poligon(
        [ RenkliNokta(Renk(10, 10, 10), Nokta(1, 1)),
          RenkliNokta(Renk(20, 20, 20), Nokta(2, 2)),
          RenkliNokta(Renk(30, 30, 30), Nokta(3, 3)) ]);

    writeln(poligon);
}
