module kapamalar_11;

import std.stdio;
import std.format;

struct Nokta {
    int x;
    int y;

    void toString(void delegate(const(char)[]) çıkış) const {
        çıkış.formattedWrite!"(%s,%s)"(x, y);
    }
}

struct Renk {
    ubyte r;
    ubyte g;
    ubyte b;

    void toString(void delegate(const(char)[]) çıkış) const {
        çıkış.formattedWrite!"RGB:%s,%s,%s"(r, g, b);
    }
}

struct RenkliNokta {
    Renk renk;
    Nokta nokta;

    void toString(void delegate(const(char)[]) çıkış) const {
        çıkış.formattedWrite!"{%s;%s}"(renk, nokta);
    }
}

struct Poligon {
    RenkliNokta[] noktalar;

    void toString(void delegate(const(char)[]) çıkış) const {
        çıkış.formattedWrite!"%s"(noktalar);
    }
}

void main() {
    auto poligon = Poligon(
        [ RenkliNokta(Renk(10, 10, 10), Nokta(1, 1)),
          RenkliNokta(Renk(20, 20, 20), Nokta(2, 2)),
          RenkliNokta(Renk(30, 30, 30), Nokta(3, 3)) ]);

    writeln(poligon);
}
