module sablonlar_2;

class Yığın(T) {
private:

    T[] elemanlar;

public:

    void ekle(T eleman) {
        elemanlar ~= eleman;
    }

    void çıkart() {
        --elemanlar.length;
    }

    T üstteki() const {
        return elemanlar[$ - 1];
    }

    size_t uzunluk() const {
        return elemanlar.length;
    }
}
import std.string;
import std.stdio;
import std.random;

struct Nokta(T) {
    T x;
    T y;

    string toString() const {
        return format("(%s,%s)", x, y);
    }
}

// -0.50 ile 0.50 arasında rasgele bir değer döndürür
double rasgele_double()
out (sonuç) {
    assert((sonuç >= -0.50) && (sonuç < 0.50));

} do {
    return (double(uniform(0, 100)) - 50) / 100;
}

// Belirtilen sayıda rasgele Nokta!double içeren bir Yığın
// döndürür
Yığın!(Nokta!double) rasgeleNoktalar(size_t adet)
out (sonuç) {
    assert(sonuç.uzunluk == adet);

} do {
    auto noktalar = new Yığın!(Nokta!double);

    foreach (i; 0 .. adet) {
        immutable nokta = Nokta!double(rasgele_double(),
                                       rasgele_double());
        writeln("ekliyorum   : ", nokta);
        noktalar.ekle(nokta);
    }

    return noktalar;
}

void main() {
    auto üstÜsteNoktalar = rasgeleNoktalar(10);

    while (üstÜsteNoktalar.uzunluk) {
        writeln("çıkartıyorum: ", üstÜsteNoktalar.üstteki);
        üstÜsteNoktalar.çıkart();
    }
}
