module uda_3;

import std.stdio;
import std.string;
import std.algorithm;
import std.conv;
import std.traits;

/* Nitelediği tanımın şifreleneceğini belirler. */
struct ŞifreliKayıt {
}

enum Renk { siyah, mavi, kırmızı }

/* Nitelediği tanımın rengini belirler. Belirtilmediği zaman
 * siyah renk varsayılır. */
struct RenkliÇıktı {
    Renk renk;
}

struct Kişi {
    /* Bu üyenin şifreleneceği ve mavi renkle yazdırılacağı
     * belirtiliyor. */
    @ŞifreliKayıt @RenkliÇıktı(Renk.mavi) string isim;

    /* Bu üye için herhangi bir nitelik belirtilmiyor. */
    string soyad;

    /* Bu üyenin kırmızı renkle yazdırılacağı belirtiliyor. */
    @RenkliÇıktı(Renk.kırmızı) string adres;
}

/* Belirtilen üyenin varsa renk niteliğinin değerini, yoksa
 * Renk.siyah değerini döndürür. */
Renk renkNiteliği(T, string üye)() {
    auto sonuç = Renk.siyah;

    foreach (nitelik; __traits(getAttributes,
                               __traits(getMember, T, üye))) {
        static if (is (typeof(nitelik) == RenkliÇıktı)) {
            sonuç = nitelik.renk;
        }
    }

    return sonuç;
}

/* Verilen dizginin Sezar şifresi ile şifrelenmişini
 * döndürür. (Uyarı: Sezar şifresi çok güçsüz bir şifreleme
 * algoritmasıdır.) */
auto şifrelisi(string değer) {
    return değer.map!(a => dchar(a + 1));
}

unittest {
    assert("abcdefghij".şifrelisi.equal("bcdefghijk"));
}

/* Belirtilen nesneyi niteliklerine uygun olarak XML düzeninde
 * yazdırır. */
void xmlOlarakYazdır(T)(T nesne) {
    writefln("<%s>", T.stringof);
    scope(exit) writefln("</%s>", T.stringof);

    foreach (üyeİsmi; __traits(allMembers, T)) {
        string değer =
            __traits(getMember, nesne, üyeİsmi).to!string;

        static if (hasUDA!(__traits(getMember, T, üyeİsmi),
                           ŞifreliKayıt)) {
            değer = değer.şifrelisi.to!string;
        }

        writefln(`  <%1$s renk="%2$s">%3$s</%1$s>`,
                 üyeİsmi, renkNiteliği!(T, üyeİsmi), değer);
    }
}

void main() {
    auto kişiler = [ Kişi("Doğu", "Doğan", "Diyarbakır"),
                     Kişi("Batı", "Batan", "Balıkesir") ];

    foreach (kişi; kişiler) {
        xmlOlarakYazdır(kişi);
    }
}
